!Program for performing dot product test on C2_acoustic module

program C2_acoustic_dot


	!Used modules 
	use sep
	use C2_acoustic
	use dot_mod
	
	
	implicit none
	real								:: dz, dx, dy, dt
	integer								:: nz, nx, ny
	logical								:: twoD
	real, dimension(:,:,:), pointer	:: rho, k
	
	call sep_init (SOURCE)
	
	!Reading dimension of the model space (and data)
	call from_par("nz",nz)
	call from_par("nx",nx)
	call from_par("ny",ny)
	call from_par("dz",dz)
	call from_par("dx",dx)
	call from_par("dy",dy)
	call from_par("dt",dt)
	
	if(ny .eq. 1) twoD = .true.
	allocate(rho(nz,nx,ny))
	call random_number(rho)
	rho = rho + 100.
	allocate(k(nz,nx,ny))
	call random_number(k)
	k = k + 100.
	
	
	!Calling the subroutines to perform dot product test
	call C2_acoustic_init(nz, nx, ny, k, rho, dt, dz, dx, dy, twoD)
	call dotp(C2_acoustic_call, nz*nx*ny, nz*nx*ny)
	
	
	call C2_acoustic_close()
	deallocate(k,rho)
	call sep_close()
	call exit (0)
	

end program C2_acoustic_dot
