!Program for performing dot product test on C2_acoustic module

program C5_acoustic_dot


	!Used modules 
	use sep
	use C5_acoustic
	use dot_mod
  	use weight
  	use G
	
	
	implicit none
	real								:: dz, dx, dy, dt
	integer								:: nz, nx, ny, nv_pad
	logical								:: twoD
	real, dimension(:,:,:), pointer		:: rho, k, junk
	
	parameter(nv_pad =10)
	
	call sep_init (SOURCE)
	
	!Reading dimension of the model space (and data)
	call from_par("nz",nz)
	call from_par("nx",nx)
	call from_par("ny",ny)
	call from_par("dz",dz)
	call from_par("dx",dx)
	call from_par("dy",dy)
	call from_par("dt",dt)
	
	
	if(ny .eq. 1) twoD = .true.
	allocate(rho(nz,nx,ny))
	call random_number(rho)
	rho = rho + 100.
	allocate(k(nz,nx,ny))
	call random_number(k)
	k = k + 100.
	
	
	
	!Calling the subroutines to perform dot product test
	allocate(junk(nz,nx,ny));junk=sqrt(k/rho)
  	call weight_init(nz,nx,ny,dt,dz,dx,dy,nv_pad,junk,twoD)
 	deallocate(junk)
  	call G_init(nz,nx,ny,dt,dz,dx,dy,nv_pad,twoD)
	call C5_acoustic_init(nz, nx, ny, k, rho, dt, dz, dx, dy, twoD)
	call dotp(C5_acoustic_call, nz*nx*ny, nz*nx*ny)

	
	call C5_acoustic_close()
	deallocate(k,rho)
	call sep_close()
	call exit (0)
	

end program C5_acoustic_dot
