!Program for performing dot product test on Db2 module

program Db2_dot


	!Used modules 
	use sep
	use Db2
	use dot_mod
	use Prop_acoustic_step
	
	
	implicit none
	real								:: dz, dx, dy
	integer								:: nz, nx, ny
	logical								:: twoD
	real, dimension(:,:,:), allocatable	:: rho
	
	call sep_init (SOURCE)
	
	!Reading dimension of the model space (and data)
	call from_par("nz",nz)
	call from_par("nx",nx)
	call from_par("ny",ny)
	call from_par("dz",dz)
	call from_par("dx",dx)
	call from_par("dy",dy)
	
	if(ny .eq. 1) then
		twoD = .true.
	else
		twoD = .false.
	endif
	allocate(rho(nz,nx,ny))
	call random_number(rho)
	rho = rho + 100.
	
	
	!Calling the subroutines to perform dot product test
	call Db2_init(nz, nx, ny, dz, dx, dy, rho, twoD)
	call dotp(Db2_call, nz*nx*ny, nz*nx*ny)
	
	
	call Db2_close()
	deallocate(rho)
	call sep_close()
	call exit (0)
	

end program Db2_dot
