!Module to read the file containing number of points and their positions
module read_pos

 contains

   subroutine reading_pos(file_in,n,x,y,z)

	implicit none
	!Arguments
	character*256, intent(in)						:: file_in
	integer, intent(out)							:: n
	real, dimension(:), allocatable, intent(inout)	:: x, y, z
	!Internal variables
	integer											:: open_stat, read_stat, i
	character*256									:: line_buffer

	!Open the file
	open(file=file_in,unit=22,form='formatted', status='old', iostat=open_stat)
  	if (open_stat .ne. 0 ) then
  		write(0,*) "Cannot read the input file for sources/receivers"
  		stop
  	endif
  	read_stat=0
	n=0
  	do while (read_stat == 0)
  		read(unit=22,fmt='(A)',iostat=read_stat) line_buffer
  		if (read_stat == 0) then
  			if (line_buffer(1:1)=='#' .or. line_buffer(2:2)=='#') cycle
        		read(line_buffer,*) n
			if(n .gt. 0) exit
  		endif
  	enddo
	!Allocate the memory for the positions
	allocate(x(n),y(n),z(n))
	!Reading the positions
	i=0
  	do while (read_stat == 0)
  		read(unit=22,fmt='(A)',iostat=read_stat) line_buffer
  		if (read_stat == 0) then
  			if (line_buffer(1:1)=='#' .or. line_buffer(2:2)=='#') cycle
       			i = i + 1
        		read(line_buffer,*) x(i), y(i), z(i)
  		endif
 	enddo

	close(22)
	return
   end subroutine reading_pos

end module read_pos
