module ricker_mod

    implicit none

    real,parameter     :: pi=3.14159265359

    contains

    subroutine ricker(nt,ot,dt,fd,td,source)
        integer                 			 :: nt,i
        real,dimension(:)			         :: source
        real                    			 :: ot,dt,fd,alpha,t,td
        alpha = (pi*fd) * (pi*fd)
        do i=1,nt
            t = ot + (i-1) * dt
            t = t - td
            source(i) = (1-2*alpha*t*t) * exp(-alpha*t*t)
        end do
    end subroutine ricker

end module